JUCE: CoreAudioFormat Class Reference

JUCE

Public Types | Public Member Functions | Static Public Attributes | List of all members
CoreAudioFormat Class Reference
juce_audio_formats » codecs

OSX and iOS only - This uses the AudioToolbox framework to read any audio format that the system has a codec for. More...

`#include <juce_CoreAudioFormat.h>`

Inheritance diagram for CoreAudioFormat:

## Public Types
enum class | StreamKind { kNone , kAiff , kAifc , kWave , kSoundDesigner2 , kNext , kMp3 , kMp2 , kMp1 , kAc3 , kAacAdts , kMpeg4 , kM4a , kM4b , kCaf , k3gp , k3gp2 , kAmr }
| File type hints. More...

## Public Member Functions
| CoreAudioFormat ()
| Creates a format object. More...
| CoreAudioFormat (StreamKind)
| Creates a format object and provides a hint as to the format of data to be read or written. More...
| ~CoreAudioFormat () override
| Destructor. More...
Array< int > | getPossibleSampleRates () override
| Returns a set of sample rates that the format can read and write. More...
Array< int > | getPossibleBitDepths () override
| Returns a set of bit depths that the format can read and write. More...
bool | canDoStereo () override
| Returns true if the format can do 2-channel audio. More...
bool | canDoMono () override
| Returns true if the format can do 1-channel audio. More...
AudioFormatReader * | createReaderFor (InputStream *, bool deleteStreamIfOpeningFails) override
| Tries to create an object that can read from a stream containing audio data in this format. More...
AudioFormatWriter * | createWriterFor (OutputStream *, double sampleRateToUse, unsigned int numberOfChannels, int bitsPerSample, const StringPairArray &metadataValues, int qualityOptionIndex) override
| Tries to create an object that can write to a stream with this audio format. More...
virtual AudioFormatWriter * | createWriterFor (OutputStream *streamToWriteTo, double sampleRateToUse, unsigned int numberOfChannels, int bitsPerSample, const StringPairArray &metadataValues, int qualityOptionIndex)=0
| Tries to create an object that can write to a stream with this audio format. More...
virtual AudioFormatWriter * | createWriterFor (OutputStream *streamToWriteTo, double sampleRateToUse, const AudioChannelSet &channelLayout, int bitsPerSample, const StringPairArray &metadataValues, int qualityOptionIndex)
| Tries to create an object that can write to a stream with this audio format. More...
Public Member Functions inherited from AudioFormat
virtual | ~AudioFormat ()
| Destructor. More...
const String & | getFormatName () const
| Returns the name of this format. More...
virtual StringArray | getFileExtensions () const
| Returns all the file extensions that might apply to a file of this format. More...
virtual bool | canHandleFile (const File &fileToTest)
| Returns true if this the given file can be read by this format. More...
virtual Array< int > | getPossibleSampleRates ()=0
| Returns a set of sample rates that the format can read and write. More...
virtual Array< int > | getPossibleBitDepths ()=0
| Returns a set of bit depths that the format can read and write. More...
virtual bool | canDoStereo ()=0
| Returns true if the format can do 2-channel audio. More...
virtual bool | canDoMono ()=0
| Returns true if the format can do 1-channel audio. More...
virtual bool | isCompressed ()
| Returns true if the format uses compressed data. More...
virtual bool | isChannelLayoutSupported (const AudioChannelSet &channelSet)
| Returns true if the channel layout is supported by this format. More...
virtual StringArray | getQualityOptions ()
| Returns a list of different qualities that can be used when writing. More...
virtual AudioFormatReader * | createReaderFor (InputStream *sourceStream, bool deleteStreamIfOpeningFails)=0
| Tries to create an object that can read from a stream containing audio data in this format. More...
virtual MemoryMappedAudioFormatReader * | createMemoryMappedReader (const File &file)
| Attempts to create a MemoryMappedAudioFormatReader, if possible for this format. More...
virtual MemoryMappedAudioFormatReader * | createMemoryMappedReader (FileInputStream *fin)
virtual AudioFormatWriter * | createWriterFor (OutputStream *streamToWriteTo, double sampleRateToUse, unsigned int numberOfChannels, int bitsPerSample, const StringPairArray &metadataValues, int qualityOptionIndex)=0
| Tries to create an object that can write to a stream with this audio format. More...
virtual AudioFormatWriter * | createWriterFor (OutputStream *streamToWriteTo, double sampleRateToUse, const AudioChannelSet &channelLayout, int bitsPerSample, const StringPairArray &metadataValues, int qualityOptionIndex)
| Tries to create an object that can write to a stream with this audio format. More...

## Static Public Attributes
static const char *const | midiDataBase64
| Metadata property name used when reading a caf file with a MIDI chunk. More...
static const char *const | tempo
| Metadata property name used when reading a caf file with tempo information. More...
static const char *const | timeSig
| Metadata property name used when reading a caf file time signature information. More...
static const char *const | keySig
| Metadata property name used when reading a caf file time signature information. More...

## Additional Inherited Members
Protected Member Functions inherited from AudioFormat
| AudioFormat (String formatName, StringArray fileExtensions)
| Creates an AudioFormat object. More...
| AudioFormat (StringRef formatName, StringRef fileExtensions)
| Creates an AudioFormat object. More...

## Detailed Description

OSX and iOS only - This uses the AudioToolbox framework to read any audio format that the system has a codec for.

This should be able to understand formats such as mp3, m4a, etc.

See also
  AudioFormat

## Member Enumeration Documentation

## ◆ StreamKind

enum class CoreAudioFormat::StreamKind
| strong

File type hints.

Enumerator
kNone |
kAiff |
kAifc |
kWave |
kSoundDesigner2 |
kNext |
kMp3 |
kMp2 |
kMp1 |
kAc3 |
kAacAdts |
kMpeg4 |
kM4a |
kM4b |
kCaf |
k3gp |
k3gp2 |
kAmr |

## Constructor & Destructor Documentation

## ◆ CoreAudioFormat() [1/2]

CoreAudioFormat::CoreAudioFormat | ( |  | ) |

Creates a format object.

## ◆ CoreAudioFormat() [2/2]

CoreAudioFormat::CoreAudioFormat | ( | StreamKind |  | ) |
| explicit

Creates a format object and provides a hint as to the format of data to be read or written.

## ◆ ~CoreAudioFormat()

CoreAudioFormat::~CoreAudioFormat | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ getPossibleSampleRates()

Array< int > CoreAudioFormat::getPossibleSampleRates | ( |  | ) |
| overridevirtual

Returns a set of sample rates that the format can read and write.

Implements AudioFormat.

## ◆ getPossibleBitDepths()

Array< int > CoreAudioFormat::getPossibleBitDepths | ( |  | ) |
| overridevirtual

Returns a set of bit depths that the format can read and write.

Implements AudioFormat.

## ◆ canDoStereo()

bool CoreAudioFormat::canDoStereo | ( |  | ) |
| overridevirtual

Returns true if the format can do 2-channel audio.

Implements AudioFormat.

## ◆ canDoMono()

bool CoreAudioFormat::canDoMono | ( |  | ) |
| overridevirtual

Returns true if the format can do 1-channel audio.

Implements AudioFormat.

## ◆ createReaderFor()

AudioFormatReader * CoreAudioFormat::createReaderFor | ( | InputStream * | sourceStream,
|  | bool | deleteStreamIfOpeningFails
| ) |  |
| overridevirtual

Tries to create an object that can read from a stream containing audio data in this format.

The reader object that is returned can be used to read from the stream, and should then be deleted by the caller.

Parameters

  sourceStream | the stream to read from - the AudioFormatReader object that is returned will delete this stream when it no longer needs it.
  deleteStreamIfOpeningFails | if no reader can be created, this determines whether this method should delete the stream object that was passed-in. (If a valid reader is returned, it will always be in charge of deleting the stream, so this parameter is ignored)

See also
  AudioFormatReader

Implements AudioFormat.

## ◆ createWriterFor() [1/3]

AudioFormatWriter * CoreAudioFormat::createWriterFor | ( | OutputStream * | streamToWriteTo,
|  | double | sampleRateToUse,
|  | unsigned int | numberOfChannels,
|  | int | bitsPerSample,
|  | const StringPairArray & | metadataValues,
|  | int | qualityOptionIndex
| ) |  |
| overridevirtual

Tries to create an object that can write to a stream with this audio format.

The writer object that is returned can be used to write to the stream, and should then be deleted by the caller.

If the stream can't be created for some reason (e.g. the parameters passed in here aren't suitable), this will return nullptr.

Parameters

  streamToWriteTo | the stream that the data will go to - this will be deleted by the AudioFormatWriter object when it's no longer needed. If no AudioFormatWriter can be created by this method, the stream will NOT be deleted, so that the caller can re-use it to try to open a different format, etc
  sampleRateToUse | the sample rate for the file, which must be one of the ones returned by getPossibleSampleRates()
  numberOfChannels | the number of channels
  bitsPerSample | the bits per sample to use - this must be one of the values returned by getPossibleBitDepths()
  metadataValues | a set of metadata values that the writer should try to write to the stream. Exactly what these are depends on the format, and the subclass doesn't actually have to do anything with them if it doesn't want to. Have a look at the specific format implementation classes to see possible values that can be used
  qualityOptionIndex | the index of one of compression qualities returned by the getQualityOptions() method. If there aren't any quality options for this format, just pass 0 in this parameter, as it'll be ignored

See also
  AudioFormatWriter

Implements AudioFormat.

## ◆ createWriterFor() [2/3]

virtual AudioFormatWriter * AudioFormat::createWriterFor | ( | OutputStream * | streamToWriteTo,
|  | double | sampleRateToUse,
|  | unsigned int | numberOfChannels,
|  | int | bitsPerSample,
|  | const StringPairArray & | metadataValues,
|  | int | qualityOptionIndex
| ) |  |
| virtual

Tries to create an object that can write to a stream with this audio format.

The writer object that is returned can be used to write to the stream, and should then be deleted by the caller.

If the stream can't be created for some reason (e.g. the parameters passed in here aren't suitable), this will return nullptr.

Parameters

  streamToWriteTo | the stream that the data will go to - this will be deleted by the AudioFormatWriter object when it's no longer needed. If no AudioFormatWriter can be created by this method, the stream will NOT be deleted, so that the caller can re-use it to try to open a different format, etc
  sampleRateToUse | the sample rate for the file, which must be one of the ones returned by getPossibleSampleRates()
  numberOfChannels | the number of channels
  bitsPerSample | the bits per sample to use - this must be one of the values returned by getPossibleBitDepths()
  metadataValues | a set of metadata values that the writer should try to write to the stream. Exactly what these are depends on the format, and the subclass doesn't actually have to do anything with them if it doesn't want to. Have a look at the specific format implementation classes to see possible values that can be used
  qualityOptionIndex | the index of one of compression qualities returned by the getQualityOptions() method. If there aren't any quality options for this format, just pass 0 in this parameter, as it'll be ignored

See also
  AudioFormatWriter

Implements AudioFormat.

## ◆ createWriterFor() [3/3]

virtual AudioFormatWriter * AudioFormat::createWriterFor | ( | OutputStream * | streamToWriteTo,
|  | double | sampleRateToUse,
|  | const AudioChannelSet & | channelLayout,
|  | int | bitsPerSample,
|  | const StringPairArray & | metadataValues,
|  | int | qualityOptionIndex
| ) |  |
| virtual

Tries to create an object that can write to a stream with this audio format.

The writer object that is returned can be used to write to the stream, and should then be deleted by the caller.

If the stream can't be created for some reason (e.g. the parameters passed in here aren't suitable), this will return nullptr.

Parameters

  streamToWriteTo | the stream that the data will go to - this will be deleted by the AudioFormatWriter object when it's no longer needed. If no AudioFormatWriter can be created by this method, the stream will NOT be deleted, so that the caller can re-use it to try to open a different format, etc
  sampleRateToUse | the sample rate for the file, which must be one of the ones returned by getPossibleSampleRates()
  channelLayout | the channel layout for the file. Use isChannelLayoutSupported to check if the writer supports this layout.
  bitsPerSample | the bits per sample to use - this must be one of the values returned by getPossibleBitDepths()
  metadataValues | a set of metadata values that the writer should try to write to the stream. Exactly what these are depends on the format, and the subclass doesn't actually have to do anything with them if it doesn't want to. Have a look at the specific format implementation classes to see possible values that can be used
  qualityOptionIndex | the index of one of compression qualities returned by the getQualityOptions() method. If there aren't any quality options for this format, just pass 0 in this parameter, as it'll be ignored

See also
  AudioFormatWriter

Reimplemented from AudioFormat.

## Member Data Documentation

## ◆ midiDataBase64

const char* const CoreAudioFormat::midiDataBase64
| static

Metadata property name used when reading a caf file with a MIDI chunk.

## ◆ tempo

const char* const CoreAudioFormat::tempo
| static

Metadata property name used when reading a caf file with tempo information.

## ◆ timeSig

const char* const CoreAudioFormat::timeSig
| static

Metadata property name used when reading a caf file time signature information.

## ◆ keySig

const char* const CoreAudioFormat::keySig
| static

Metadata property name used when reading a caf file time signature information.

The documentation for this class was generated from the following file:

- juce_CoreAudioFormat.h